#include "keyboard.hpp"
#include "color.h"
#include "display.h"
#include "keyboard_syscalls.h"
#include "NyanCat.h"

void CopySprite(const void* datar, int x, int y, int width, int height) {
   color_t*data = (color_t*) datar;
   color_t* VRAM = (color_t*)0xA8000000;
   VRAM += LCD_WIDTH_PX*y + x;
   for(int j=y; j<y+height; j++) {
      for(int i=x; i<x+width; i++) {
         *(VRAM++) = *(data++);
     }
     VRAM += LCD_WIDTH_PX-width;
   }
}
int PRGM_GetKey(){
  unsigned char buffer[12];
  PRGM_GetKey_OS( buffer );
  return ( buffer[1] & 0x0F ) * 10 + ( ( buffer[2] & 0xF0 ) >> 4 );
}

int main() {
  while(1) {
    int key = PRGM_GetKey();
    if(key == KEY_PRGM_MENU) {  GetKey(&key); }
    CopySprite(NyanCat1, 0, 0, 160, 160); 
    Bdisp_PutDisp_DD();
    Bdisp_AllCr_VRAM();
    CopySprite(NyanCat2, 0, 0, 160, 160); 
    Bdisp_PutDisp_DD();
    Bdisp_AllCr_VRAM();
    CopySprite(NyanCat3, 0, 0, 160, 160); 
    Bdisp_PutDisp_DD();
    Bdisp_AllCr_VRAM();
    CopySprite(NyanCat4, 0, 0, 160, 160); 
    Bdisp_PutDisp_DD();
    Bdisp_AllCr_VRAM();
    CopySprite(NyanCat5, 0, 0, 160, 160); 
    Bdisp_PutDisp_DD();
    Bdisp_AllCr_VRAM();
    CopySprite(NyanCat6, 0, 0, 160, 160); 
    Bdisp_PutDisp_DD();
    Bdisp_AllCr_VRAM();
    CopySprite(NyanCat7, 0, 0, 160, 160); 
    Bdisp_PutDisp_DD();
    Bdisp_AllCr_VRAM();
    CopySprite(NyanCat8, 0, 0, 160, 160); 
    Bdisp_PutDisp_DD();
    Bdisp_AllCr_VRAM();
    CopySprite(NyanCat9, 0, 0, 160, 160); 
    Bdisp_PutDisp_DD();
    Bdisp_AllCr_VRAM();
    CopySprite(NyanCat10, 0, 0, 160, 160); 
    Bdisp_PutDisp_DD();
    Bdisp_AllCr_VRAM();
    CopySprite(NyanCat11, 0, 0, 160, 160); 
    Bdisp_PutDisp_DD();
    Bdisp_AllCr_VRAM();
    CopySprite(NyanCat12, 0, 0, 160, 160); 
    Bdisp_PutDisp_DD();
    Bdisp_AllCr_VRAM();
  }
  return 0;
}
